CfnStateMachine L1 construct
Provisions a state machine.
A state machine consists of a collection of states that can do work ( Task states), determine to which states to transition next ( Choice states), stop an execution with an error ( Fail states), and so on. State machines are specified using a JSON-based, structured language.
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_stepfunctions as stepfunctions } from 'aws-cdk-lib';
declare const definition: any;
const cfnStateMachine = new stepfunctions.CfnStateMachine(this, 'MyCfnStateMachine', {
roleArn: 'roleArn',
// the properties below are optional
definition: definition,
definitionS3Location: {
bucket: 'bucket',
key: 'key',
// the properties below are optional
version: 'version',
},
definitionString: 'definitionString',
definitionSubstitutions: {
definitionSubstitutionsKey: 'definitionSubstitutions',
},
encryptionConfiguration: {
type: 'type',
// the properties below are optional
kmsDataKeyReusePeriodSeconds: 123,
kmsKeyId: 'kmsKeyId',
},
loggingConfiguration: {
destinations: [{
cloudWatchLogsLogGroup: {
logGroupArn: 'logGroupArn',
},
}],
includeExecutionData: false,
level: 'level',
},
stateMachineName: 'stateMachineName',
stateMachineType: 'stateMachineType',
tags: [{
key: 'key',
value: 'value',
}],
tracingConfiguration: {
enabled: false,
},
});
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_stepfunctions as stepfunctions
# definition: Any
cfn_state_machine = stepfunctions.CfnStateMachine(self, "MyCfnStateMachine",
role_arn="roleArn",
# the properties below are optional
definition=definition,
definition_s3_location=stepfunctions.CfnStateMachine.S3LocationProperty(
bucket="bucket",
key="key",
# the properties below are optional
version="version"
),
definition_string="definitionString",
definition_substitutions={
"definition_substitutions_key": "definitionSubstitutions"
},
encryption_configuration=stepfunctions.CfnStateMachine.EncryptionConfigurationProperty(
type="type",
# the properties below are optional
kms_data_key_reuse_period_seconds=123,
kms_key_id="kmsKeyId"
),
logging_configuration=stepfunctions.CfnStateMachine.LoggingConfigurationProperty(
destinations=[stepfunctions.CfnStateMachine.LogDestinationProperty(
cloud_watch_logs_log_group=stepfunctions.CfnStateMachine.CloudWatchLogsLogGroupProperty(
log_group_arn="logGroupArn"
)
)],
include_execution_data=False,
level="level"
),
state_machine_name="stateMachineName",
state_machine_type="stateMachineType",
tags=[stepfunctions.CfnStateMachine.TagsEntryProperty(
key="key",
value="value"
)],
tracing_configuration=stepfunctions.CfnStateMachine.TracingConfigurationProperty(
enabled=False
)
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.stepfunctions.*;
Object definition;
CfnStateMachine cfnStateMachine = CfnStateMachine.Builder.create(this, "MyCfnStateMachine")
.roleArn("roleArn")
// the properties below are optional
.definition(definition)
.definitionS3Location(S3LocationProperty.builder()
.bucket("bucket")
.key("key")
// the properties below are optional
.version("version")
.build())
.definitionString("definitionString")
.definitionSubstitutions(Map.of(
"definitionSubstitutionsKey", "definitionSubstitutions"))
.encryptionConfiguration(EncryptionConfigurationProperty.builder()
.type("type")
// the properties below are optional
.kmsDataKeyReusePeriodSeconds(123)
.kmsKeyId("kmsKeyId")
.build())
.loggingConfiguration(LoggingConfigurationProperty.builder()
.destinations(List.of(LogDestinationProperty.builder()
.cloudWatchLogsLogGroup(CloudWatchLogsLogGroupProperty.builder()
.logGroupArn("logGroupArn")
.build())
.build()))
.includeExecutionData(false)
.level("level")
.build())
.stateMachineName("stateMachineName")
.stateMachineType("stateMachineType")
.tags(List.of(TagsEntryProperty.builder()
.key("key")
.value("value")
.build()))
.tracingConfiguration(TracingConfigurationProperty.builder()
.enabled(false)
.build())
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.StepFunctions;
var definition;
var cfnStateMachine = new CfnStateMachine(this, "MyCfnStateMachine", new CfnStateMachineProps {
RoleArn = "roleArn",
// the properties below are optional
Definition = definition,
DefinitionS3Location = new S3LocationProperty {
Bucket = "bucket",
Key = "key",
// the properties below are optional
Version = "version"
},
DefinitionString = "definitionString",
DefinitionSubstitutions = new Dictionary<string, string> {
{ "definitionSubstitutionsKey", "definitionSubstitutions" }
},
EncryptionConfiguration = new EncryptionConfigurationProperty {
Type = "type",
// the properties below are optional
KmsDataKeyReusePeriodSeconds = 123,
KmsKeyId = "kmsKeyId"
},
LoggingConfiguration = new LoggingConfigurationProperty {
Destinations = new [] { new LogDestinationProperty {
CloudWatchLogsLogGroup = new CloudWatchLogsLogGroupProperty {
LogGroupArn = "logGroupArn"
}
} },
IncludeExecutionData = false,
Level = "level"
},
StateMachineName = "stateMachineName",
StateMachineType = "stateMachineType",
Tags = new [] { new TagsEntryProperty {
Key = "key",
Value = "value"
} },
TracingConfiguration = new TracingConfigurationProperty {
Enabled = false
}
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
var definition interface{}
cfnStateMachine := awscdk.Aws_stepfunctions.NewCfnStateMachine(this, jsii.String("MyCfnStateMachine"), &CfnStateMachineProps{
RoleArn: jsii.String("roleArn"),
// the properties below are optional
Definition: definition,
DefinitionS3Location: &S3LocationProperty{
Bucket: jsii.String("bucket"),
Key: jsii.String("key"),
// the properties below are optional
Version: jsii.String("version"),
},
DefinitionString: jsii.String("definitionString"),
DefinitionSubstitutions: map[string]*string{
"definitionSubstitutionsKey": jsii.String("definitionSubstitutions"),
},
EncryptionConfiguration: &EncryptionConfigurationProperty{
Type: jsii.String("type"),
// the properties below are optional
KmsDataKeyReusePeriodSeconds: jsii.Number(123),
KmsKeyId: jsii.String("kmsKeyId"),
},
LoggingConfiguration: &LoggingConfigurationProperty{
Destinations: []interface{}{
&LogDestinationProperty{
CloudWatchLogsLogGroup: &CloudWatchLogsLogGroupProperty{
LogGroupArn: jsii.String("logGroupArn"),
},
},
},
IncludeExecutionData: jsii.Boolean(false),
Level: jsii.String("level"),
},
StateMachineName: jsii.String("stateMachineName"),
StateMachineType: jsii.String("stateMachineType"),
Tags: []TagsEntryProperty{
&TagsEntryProperty{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
TracingConfiguration: &TracingConfigurationProperty{
Enabled: jsii.Boolean(false),
},
})
Initializer
new CfnStateMachine(scope: Construct, id: string, props: CfnStateMachineProps)
CfnStateMachine(scope: Construct, id: str, props: CfnStateMachineProps)
new CfnStateMachine(Construct scope, String id, CfnStateMachineProps props)
new CfnStateMachine(Construct scope, string id, CfnStateMachineProps props)
NewCfnStateMachine(Scope Construct, Id *string, Props CfnStateMachineProps)
Construct Props
notes
The state machine definition must be in JSON or YAML, and the format of the object must match the format of your CloudFormation template file. See Amazon States Language .
definitionS3LocationIResolvable | CfnStateMachine.S3LocationPropertydefinition_s3_locationtyping.Union[IResolvable, S3LocationProperty]definitionS3LocationIResolvableDefinitionS3LocationIResolvableDefinitionS3Locationinterface{}#The state machine definition must be a JSON or YAML file.
definitionStringstring | ITableRef | ITaskDefinitionRef | IFunctionRef | IVersionRef | ITopicRef | IQueueRefdefinition_stringtyping.Union[str, ITableRef, ITaskDefinitionRef, IFunctionRef, IVersionRef, ITopicRef, IQueueRef]definitionStringStringDefinitionStringstringDefinitionStringinterface{}#The state machine definition must be in JSON. See Amazon States Language .
definitionSubstitutionsIResolvable | { [key: string]: string }definition_substitutionstyping.Union[IResolvable, typing.Mapping[str, str]]definitionSubstitutionsIResolvableDefinitionSubstitutionsIResolvableDefinitionSubstitutionsinterface{}#notes
This enables the customer to inject values obtained at runtime, for example from intrinsic functions, in the state machine definition. Variables can be template parameter names, resource logical IDs, resource attributes, or a variable in a key-value map.
Substitutions must follow the syntax: ${key_name} or ${variable_1,variable_2,...} .
encryptionConfigurationIResolvable | CfnStateMachine.EncryptionConfigurationPropertyencryption_configurationtyping.Union[IResolvable, EncryptionConfigurationProperty]encryptionConfigurationIResolvableEncryptionConfigurationIResolvableEncryptionConfigurationinterface{}#loggingConfigurationIResolvable | CfnStateMachine.LoggingConfigurationPropertylogging_configurationtyping.Union[IResolvable, LoggingConfigurationProperty]loggingConfigurationIResolvableLoggingConfigurationIResolvableLoggingConfigurationinterface{}#By default, the
levelis set toOFF. For more information see Log Levels in the AWS Step Functions User Guide.
roleArnstring | IRoleRefrole_arntyping.Union[str, IRoleRef]roleArnStringRoleArnstringRoleArninterface{}required#stateMachineNamestringstate_machine_namestrstateMachineNameStringStateMachineNamestringStateMachineName*string#notes
A name must not contain:
- white space
- brackets
< > { } [ ] - wildcard characters
? * - special characters
" # % \ ^ | ~$ & , ; : /` - control characters (
U+0000-001F,U+007F-009F)
If you specify a name, you cannot perform updates that require replacement of this resource. You can perform updates that require no or some interruption. If you must replace the resource, specify a new name.
stateMachineTypestringstate_machine_typestrstateMachineTypeStringStateMachineTypestringStateMachineType*string#notes
The default is STANDARD . You cannot update the type of a state machine once it has been created. For more information on STANDARD and EXPRESS workflows, see Standard Versus Express Workflows in the AWS Step Functions Developer Guide.
tagsCfnStateMachine.TagsEntryProperty[]tagstyping.List[TagsEntryProperty]tagsList<TagsEntryProperty>TagsTagsEntryProperty[]Tags*[]TagsEntryProperty#Tags may only contain Unicode letters, digits, white space, or these symbols: `_ . : / = + -
tracingConfigurationIResolvable | CfnStateMachine.TracingConfigurationPropertytracing_configurationtyping.Union[IResolvable, TracingConfigurationProperty]tracingConfigurationIResolvableTracingConfigurationIResolvableTracingConfigurationinterface{}#Properties
notes
{ "Fn::GetAtt": ["MyStateMachine", "Name"] }
Returns the name of your state machine:
HelloWorld-StateMachine
If you did not specify the name it will be similar to the following:
MyStateMachine-1234abcdefgh
For more information about using Fn::GetAtt , see Fn::GetAtt .
attrStateMachineRevisionIdstringattr_state_machine_revision_idstrattrStateMachineRevisionIdStringAttrStateMachineRevisionIdstringAttrStateMachineRevisionId*stringrequired#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#definitionS3LocationIResolvable | CfnStateMachine.S3LocationPropertydefinition_s3_locationtyping.Union[IResolvable, S3LocationProperty]definitionS3LocationIResolvableDefinitionS3LocationIResolvableDefinitionS3Locationinterface{}#definitionStringstringdefinition_stringstrdefinitionStringStringDefinitionStringstringDefinitionString*string#definitionSubstitutionsIResolvable | { [key: string]: string }definition_substitutionstyping.Union[IResolvable, typing.Mapping[str, str]]definitionSubstitutionsIResolvableDefinitionSubstitutionsIResolvableDefinitionSubstitutionsinterface{}#encryptionConfigurationIResolvable | CfnStateMachine.EncryptionConfigurationPropertyencryption_configurationtyping.Union[IResolvable, EncryptionConfigurationProperty]encryptionConfigurationIResolvableEncryptionConfigurationIResolvableEncryptionConfigurationinterface{}#loggingConfigurationIResolvable | CfnStateMachine.LoggingConfigurationPropertylogging_configurationtyping.Union[IResolvable, LoggingConfigurationProperty]loggingConfigurationIResolvableLoggingConfigurationIResolvableLoggingConfigurationinterface{}#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
CfnElements must be defined within a stack scope (directly or indirectly).
stateMachineNamestringstate_machine_namestrstateMachineNameStringStateMachineNamestringStateMachineName*string#stateMachineRefStateMachineReferencestate_machine_refStateMachineReferencestateMachineRefStateMachineReferenceStateMachineRefStateMachineReferenceStateMachineRefStateMachineReferencerequired#stateMachineTypestringstate_machine_typestrstateMachineTypeStringStateMachineTypestringStateMachineType*string#tagsRawCfnStateMachine.TagsEntryProperty[]tags_rawtyping.List[TagsEntryProperty]tagsRawList<TagsEntryProperty>TagsRawTagsEntryProperty[]TagsRaw*[]TagsEntryProperty#tracingConfigurationIResolvable | CfnStateMachine.TracingConfigurationPropertytracing_configurationtyping.Union[IResolvable, TracingConfigurationProperty]tracingConfigurationIResolvableTracingConfigurationIResolvableTracingConfigurationinterface{}#Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
arnForStateMachine(resource: IStateMachineRef): string@staticmethod def arn_for_state_machine(resource: IStateMachineRef) -> strpublic static String arnForStateMachine(IStateMachineRef resource)public static string ArnForStateMachine(IStateMachineRef resource)func ArnForStateMachine(Resource IStateMachineRef) *stringstatic#cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isCfnStateMachine(x: any): boolean@staticmethod def is_cfn_state_machine(x: Any) -> boolpublic static Boolean isCfnStateMachine(Object x)public static bool IsCfnStateMachine(object x)func IsCfnStateMachine(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.